/** @file oggdec_filter.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.21
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef OGGDEC_FILTER_CMDLINE_H
#define OGGDEC_FILTER_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef OGGDEC_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define OGGDEC_CMDLINE_PARSER_PACKAGE "oggdec_filter"
#endif

#ifndef OGGDEC_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define OGGDEC_CMDLINE_PARSER_VERSION "(paraslash 0.2.17, isotropic threshold)"
#endif

/** @brief Where the command line options are stored */
struct oggdec_filter_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int bufsize_arg;	/**< @brief size of output buffer (default='128').  */
  char * bufsize_orig;	/**< @brief size of output buffer original value given at command line.  */
  const char *bufsize_help; /**< @brief size of output buffer help description.  */
  int initial_buffer_arg;	/**< @brief size of initial input buffer (default='16').  */
  char * initial_buffer_orig;	/**< @brief size of initial input buffer original value given at command line.  */
  const char *initial_buffer_help; /**< @brief size of initial input buffer help description.  */
  
  int help_given ;	/**< @brief Whether help was given.  */
  int version_given ;	/**< @brief Whether version was given.  */
  int bufsize_given ;	/**< @brief Whether bufsize was given.  */
  int initial_buffer_given ;	/**< @brief Whether initial_buffer was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct oggdec_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure oggdec_filter_args_info (default 0) */
  int check_required; /**< @brief whether to check that all required options were provided (default 0) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure oggdec_filter_args_info (default 0) */
} ;

/** @brief the purpose string of the program */
extern const char *oggdec_filter_args_info_purpose;
/** @brief the usage string of the program */
extern const char *oggdec_filter_args_info_usage;
/** @brief all the lines making the help output */
extern const char *oggdec_filter_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int oggdec_cmdline_parser (int argc, char * const *argv,
  struct oggdec_filter_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use oggdec_cmdline_parser_ext() instead
 */
int oggdec_cmdline_parser2 (int argc, char * const *argv,
  struct oggdec_filter_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int oggdec_cmdline_parser_ext (int argc, char * const *argv,
  struct oggdec_filter_args_info *args_info,
  struct oggdec_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int oggdec_cmdline_parser_file_save(const char *filename,
  struct oggdec_filter_args_info *args_info);

/**
 * Print the help
 */
void oggdec_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void oggdec_cmdline_parser_print_version(void);

/**
 * Allocates dynamically a oggdec_cmdline_parser_params structure and initializes
 * all its fields to 0
 * @return the initialized oggdec_cmdline_parser_params structure
 */
struct oggdec_cmdline_parser_params *oggdec_cmdline_parser_params_init(void);

/**
 * Initializes the passed oggdec_filter_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void oggdec_cmdline_parser_init (struct oggdec_filter_args_info *args_info);
/**
 * Deallocates the string fields of the oggdec_filter_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void oggdec_cmdline_parser_free (struct oggdec_filter_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int oggdec_cmdline_parser_required (struct oggdec_filter_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* OGGDEC_FILTER_CMDLINE_H */
